﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;

namespace sl_ChartView_615967
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var data = this.GetData();
            this.DataContext = data;
        }

        private object GetData()
        {
            var data = new List<PlotInfo>() 
            {
                new PlotInfo { Letter = "A", Number = "I", YVal = 17, },
                new PlotInfo { Letter = "B", Number = "I", YVal = 22, },
                new PlotInfo { Letter = "C", Number = "I", YVal = 22, },
                new PlotInfo { Letter = "D", Number = "I", YVal = 15, },

                new PlotInfo { Letter = "A", Number = "II", YVal = 7, },
                new PlotInfo { Letter = "B", Number = "II", YVal = 5, },
                new PlotInfo { Letter = "C", Number = "II", YVal = 5, },
                new PlotInfo { Letter = "D", Number = "II", YVal = 11, },
                
                new PlotInfo { Letter = "A", Number = "III", YVal = 15, },
                new PlotInfo { Letter = "B", Number = "III", YVal = 15, },
                new PlotInfo { Letter = "C", Number = "III", YVal = 20, },
                new PlotInfo { Letter = "D", Number = "III", YVal = 14, },
            };

            return data;
        }
    }

    public class PlotInfo
    {
        public string Letter { get; set; }
        public string Number { get; set; }
        public double YVal { get; set; }

        public string XCat { get { return this.Letter + " " + this.Number; } }
    }

    public class ToLetterConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string xCat = (string)value;

            if (xCat == null)
                return "null";

            return xCat[0];
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class ToNumberConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string xCat = (string)value;

            if (xCat == null)
                return null;

            if (xCat[0] == 'C')
                return xCat.Substring(2, xCat.Length - 2);
            else
                return " ";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public class NumberToBrushConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            string number = (string)value;

            switch (number)
            {
                case "I": return new SolidColorBrush(Colors.Purple);
                case "II": return new SolidColorBrush(Colors.Red);
                case "III": return new SolidColorBrush(Colors.Green);

                default:
                    return new SolidColorBrush(Colors.Black);
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }    
}
